#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <math.h>


#define ILOSC 22
#define CZAS_CZUJNIKA 1
#define CZAS_SEKWENCJI_WL 500
#define CZAS_SEKWENCJI_WYL 20
#define CZAS_SWIECENIA 30000
#define POZIOM_PRZEL 7
//sterowanie ledami
int opcja = 0;
volatile ledy[24] = {0};


//czujniki
int czas_czujnika = 0;
volatile zezwolenie_wl1 = 0;
volatile zezwolenie_wl2 = 0;

//włączanie1
int czas_wl = 0;
int pozycja_led_wl1 = 0;
int pozycja_led_wl1a = 0;
int pentla_led1 = 0;

//włączanie1 test
volatile zezwolenie_wl11[ILOSC];
volatile tabela_wl11[ILOSC];


//włączanie2
int pozycja_led_wl2 = 0;
int pentla_led2 = 0;

//wyłączanie
int zezwolenie_wyl = 0;
int pozycja_led_wyl = 0;
int oczekiwanie_wyl = 0;
int czas_wyl = 0;



//tablica włączania
//int tablica_wl[16] = {0,5,11,18,24,31,39,47,57,68,81,97,117,145,186,155};
int tablica_wl[16] = {0,3,8,15,24,35,48,63,80,99,120,143,168,195,224,255};




SIGNAL (SIG_OVERFLOW0)
{
TCNT0=0x00;

opcja++;
if(opcja > 16)
{
opcja = 1;
}




switch (opcja)
{
case 1:
PORTC = 0b00000001;
PORTD = 0b00000000;
OCR1A = ledy[0];
OCR1B = ledy[1];
OCR2 = ledy[2];
break;

case 2:
PORTC = 0b00000000;
PORTD = 0b00000000;
OCR1A = 0;
OCR1B = 0;
OCR2 = 0;
break;


case 3:
PORTC = 0b00000010;
PORTD = 0b00000000;
OCR1A = ledy[3];
OCR1B = ledy[4];
OCR2 = ledy[5];
break;

case 4:
PORTC = 0b00000000;
PORTD = 0b00000000;
OCR1A = 0;
OCR1B = 0;
OCR2 = 0;
break;


case 5:
PORTC = 0b00000100;
PORTD = 0b00000000;
OCR1A = ledy[6];
OCR1B = ledy[7];
OCR2 = ledy[8];
break;

case 6:
PORTC = 0b00000000;
PORTD = 0b00000000;
OCR1A = 0;
OCR1B = 0;
OCR2 = 0;
break;


case 7:
PORTC = 0b00001000;
PORTD = 0b00000000;
OCR1A = ledy[9];
OCR1B = ledy[10];
OCR2 = ledy[11];
break;

case 8:
PORTC = 0b00000000;
PORTD = 0b00000000;
OCR1A = 0;
OCR1B = 0;
OCR2 = 0;
break;


case 9:
PORTC = 0b00010000;
PORTD = 0b00000000;
OCR1A = ledy[12];
OCR1B = ledy[13];
OCR2 = ledy[14];
break;

case 10:
PORTC = 0b00000000;
PORTD = 0b00000000;
OCR1A = 0;
OCR1B = 0;
OCR2 = 0;
break;


case 11:
PORTC = 0b00100000;
PORTD = 0b00000000;
OCR1A = ledy[15];
OCR1B = ledy[16];
OCR2 = ledy[17];
break;

case 12:
PORTC = 0b00000000;
PORTD = 0b00000000;
OCR1A = 0;
OCR1B = 0;
OCR2 = 0;
break;


case 13:
PORTC = 0b00000000;
PORTD = 0b00000001;
OCR1A = ledy[18];
OCR1B = ledy[19];
OCR2 = ledy[20];
break;

case 14:
PORTC = 0b00000000;
PORTD = 0b00000000;
OCR1A = 0;
OCR1B = 0;
OCR2 = 0;
break;

case 15:
PORTC = 0b00000000;
PORTD = 0b00000010;
OCR1A = ledy[21];
OCR1B = ledy[22];
OCR2 = ledy[23];
break;

case 16:
PORTC = 0b00000000;
PORTD = 0b00000000;
OCR1A = 0;
OCR1B = 0;
OCR2 = 0;
break;


}



	if(bit_is_set(PIND,PD7))
	{
		zezwolenie_wl1 = 1;
		zezwolenie_wyl = 0;
		oczekiwanie_wyl = CZAS_SWIECENIA;
	}

	if(bit_is_set(PIND,PD6))
	{
		zezwolenie_wl2 = 1;
		zezwolenie_wyl = 0;
		oczekiwanie_wyl = CZAS_SWIECENIA;
	}


if(oczekiwanie_wyl > 0) oczekiwanie_wyl--;

if(++czas_wl > 1023) czas_wl = 0;

if(++czas_wl > CZAS_SEKWENCJI_WL)
{
	if(zezwolenie_wl1 == 1)
	{
	
		
		
		pozycja_led_wyl = 0;
		if(ledy[pozycja_led_wl1] < tablica_wl[++pentla_led1]) ledy[pozycja_led_wl1] = tablica_wl[pentla_led1];
		if(pentla_led1 >= 15)
		{
			pentla_led1 = 0;
			if(++pozycja_led_wl1 > ILOSC-1) pozycja_led_wl1 = zezwolenie_wl1 = 0;
		}
		
		
	}

	if(zezwolenie_wl2 == 1)
	{
		czas_wl = 0;
		pozycja_led_wyl = 0;
		if(ledy[ILOSC-1-pozycja_led_wl2] < tablica_wl[++pentla_led2]) ledy[ILOSC-1-pozycja_led_wl2] =  tablica_wl[pentla_led2];
		if(pentla_led2 >= 15)
		{
			pentla_led2 = 0;
			if(++pozycja_led_wl2 > ILOSC-1) pozycja_led_wl2 = zezwolenie_wl2 = 0;
		}
	}




}




if(oczekiwanie_wyl == 1)
{
	zezwolenie_wyl = 1;
}

if(++czas_wyl > CZAS_SEKWENCJI_WYL && zezwolenie_wyl == 1 && zezwolenie_wl1 == 0 && zezwolenie_wl2 == 0)
{
	czas_wyl = 0;
	ledy[pozycja_led_wyl] = ledy[ILOSC-pozycja_led_wyl-1] = 255 - pentla_led1++;
	if(pentla_led1 > 255)
	{
		pentla_led1 = 0;
		if(++pozycja_led_wyl > ILOSC/2) pozycja_led_wyl = zezwolenie_wyl = 0;
	}
}



}


int main (void)
{
DDRB=0xFF;
DDRD=0b00000011;
DDRC=0xFF;
PORTB=0x00;
PORTD=0x00;
TCCR0=0b00000010;
TCNT0=0xFF;
TCCR1A=0b10100001;
TCCR1B=0b00000001;
TCCR2=0b01100001;
//PWM1
OCR1A=0x00;
//PWM2
OCR1B=0x00;
//PWM3
OCR2=0x00;
//TIMSK=1<<TOIE0;
TIMSK=0b00000001;


sei();
int i;
/*
for(i=0;i<=ILOSC;i++)
{
ledy[i] = 0;
}
*/
while(1)

{



}

}
